
//
//	PhoneDialer: Whlen von Telefonnummern per Hayes-Modem
//
//		(c) B.Eckstein, be@epost.de, 2003
//
//  ---------------------------------------------------------------------
//
//	? History im Profileverzeichnis des aktuellen Users ablegen
//	+ Handler zum Klick auf Anchor mit wtai://wp/mc;\s+0241470510 
//	+ Handler zum Klick auf Anchor mit tel: nach RFC2806
//	+ Handler fuer Kommandozeilenoption "-dizzy"
//	+ Drag and Drop einer Selection ueber den Dail-Button
//	+ alle Strings nach locale
//	+ about:dizzy
//	+ Tool zum Konvertieren von html-Phonebooks in bookmarks
//	+ Tool zum erzeugen einer RDF-Datei e164-Countrycodes
//	+ Support fuer Nebenstellenanlagen und Ortswahl/Fernwahl
// 	+ Dialcommand und Devicewahl in die Preferences mit overlay
//	+ xpi erzeugen
//	+ Sinnvolles Nutzen/Aufrumen des Menubar "File" und "Edit"
//	+ dtmf-Toene ausgeben
//	+ Dial einer Selection per Contextmenu
//	+ Kommandozeile um Uebergabe einer Nummer erweitern
//	+ dtmf-sounds korrekt ablaengen und passende Pausen.
//
//	- Toolbar: [number-to-enter] [dtmf] [dial]
//	- Import per Fileselector aus einer XML-Datei direkt in die bookmarks
//	- Eintraege im Kontextmenue nur enabled, wenn gltige Nummer selektiert.
//	- Eintrag im Kontextmenu fr dtmf
//	- Beim expliziten Besttigen (dialack) kein confirm(), sondern nur
//	  Nummer in Dizzy-Window anzeigen -> User muss selber klicken
//	- js-interne Texte als stringBundles in locale/properties-files
//	o Bug in der cc-Liste beim Anzeigen in den Preferences
//	o Verfeinerte cmd-Generierung fr VMS, OS2, MAC, SUN
//	o Feinschliff unter Linux und OpenVMS
//	o Anbinden an das Adressbuch
//	- Andere Fenster (Navigator, Addressbook) koennen ueber
//	  das Window-Menue nicht geoeffnet werden.
//
include('chrome://dizzy/content/version.js');


// Kram aus der jslib fuer das Datei- und I/O-Handling ...
//
include('chrome://dizzy/content/jslib/io/io.js');


// Der dtmf-Krempel
//
include('chrome://dizzy/content/jslib/sound/sound.js');
var gDizzySound = new Array;
gDizzySound['0'] = new Sound( "chrome://dizzy/content/dtmf/dtmf100ms0.wav");
gDizzySound['1'] = new Sound( "chrome://dizzy/content/dtmf/dtmf100ms1.wav");
gDizzySound['2'] = new Sound( "chrome://dizzy/content/dtmf/dtmf100ms2.wav");
gDizzySound['3'] = new Sound( "chrome://dizzy/content/dtmf/dtmf100ms3.wav");
gDizzySound['4'] = new Sound( "chrome://dizzy/content/dtmf/dtmf100ms4.wav");
gDizzySound['5'] = new Sound( "chrome://dizzy/content/dtmf/dtmf100ms5.wav");
gDizzySound['6'] = new Sound( "chrome://dizzy/content/dtmf/dtmf100ms6.wav");
gDizzySound['7'] = new Sound( "chrome://dizzy/content/dtmf/dtmf100ms7.wav");
gDizzySound['8'] = new Sound( "chrome://dizzy/content/dtmf/dtmf100ms8.wav");
gDizzySound['9'] = new Sound( "chrome://dizzy/content/dtmf/dtmf100ms9.wav");
gDizzySound['a'] = new Sound( "chrome://dizzy/content/dtmf/dtmf100msA.wav");
gDizzySound['b'] = new Sound( "chrome://dizzy/content/dtmf/dtmf100msB.wav");
gDizzySound['c'] = new Sound( "chrome://dizzy/content/dtmf/dtmf100msC.wav");
gDizzySound['d'] = new Sound( "chrome://dizzy/content/dtmf/dtmf100msD.wav");
gDizzySound['*'] = new Sound( "chrome://dizzy/content/dtmf/dtmf100msS.wav");
gDizzySound['#'] = new Sound( "chrome://dizzy/content/dtmf/dtmf100msH.wav");

// und nachfolgendes fuer die LRU-Liste
//
var RDFC = '@mozilla.org/rdf/container;1';
RDFC = Components.classes[RDFC].createInstance();
RDFC = RDFC.QueryInterface(Components.interfaces.nsIRDFContainer);

var RDFCUtils = '@mozilla.org/rdf/container-utils;1';
RDFCUtils = Components.classes[RDFCUtils].getService();
RDFCUtils = RDFCUtils.QueryInterface(Components.interfaces.nsIRDFContainerUtils);

var RDF = '@mozilla.org/rdf/rdf-service;1'
RDF = Components.classes[RDF].getService();
RDF = RDF.QueryInterface(Components.interfaces.nsIRDFService);

var dsource;


	// onloadDizzy() wird ausgefuehrt, wenn das Dialer-Fenster geladen wird
	//
function onloadDizzy( )
	{
	RecentListInit( );

	if( "arguments" in window && 0 in window.arguments &&
		typeof window.arguments[0] == "string" )
		{
		gotoTelSEL( window.arguments[0] );	// cmdLine-Argument
		}

	if( "arguments" in window && 0 in window.arguments &&
		typeof window.arguments[0] == "object" )
		{
		if( window.arguments[0].url )	// preset by URL-Handler
			gotoTelURL( window.arguments[0].url );

		if( window.arguments[0].sel )	// preset by contentSelection
			gotoTelSEL( window.arguments[0].sel );
		}

	return true;
	}


	// onunloadDizzy() wird ausgefhrt, wenn das Dialer-Fenster geschlossen wird
	//
function onunloadDizzy( )
	{
	return true;
	}





// ---------------------------------------------------------
//
//	Display-Fuctions
//

	//	Alle Ziffern im Display werden entfernt
	//
function clearDisplay( )
	{
	var display = document.getElementById("display");
	display.value = "";
	}


function normalizeNumber( value )
	{
	value = value.replace( /\s+/g, "" );
	value = value.replace( /\.+/g, "" );
	value = value.replace( /\-+/g, "" );

	var prefAmtsKennziffer = getCharPref( "pbx.exchange", "0"   );
	var prefStellenintern  = [];

//	if( !getBoolPref("flag.havepbx", false) ) { return value };

	for( i=0; i<10; i++ )
		{
		prefStellenintern[i] = getIntPref( "pbx.grouplen."+i, "1" );
		}

	if( value.length != prefStellenintern[value[0]] )
		{
		if( (value[0] >= 0) && (value[0] <= 9) )
			{
			value = prefAmtsKennziffer + value;
			}
		}

	return value;
	}


	// eine Telefonnummer nach RFC2806 wird an die lokalen
	// Gegebenheiten (Amtsholung, NSt, etc.) angepasst
	// ACHTUNG: Kann nicht alles nach RFC2806
	//
function localizeNumber( value )
	{
	value = unescape( value );
	value = value.replace( /\s+/g, "" );
	value = value.replace( /\.+/g, "" );
	value = value.replace( /\-+/g, "" );

	var prefVorwahlFernamt	= getCharPref( "loc.trunkprefix", '' );
	var prefVorwahlIntlamt	= getCharPref( "loc.intl_prefix", '' );
	var prefLandesKennzahl	= getCharPref( "loc.countrycode", '' );
	var prefVorwahl		= getCharPref( "loc.areacode",    '' );
	var prefSubscriber      = getCharPref( "loc.subscriber",  '' );
	var prefHavePBX         = getBoolPref( "flag.havepbx",    false );
	var prefAmtsKennziffer  = getCharPref( "pbx.exchange",    '' );

	if( value[0] == '+' )
		{
		var nr = /\+(\d+)\((\d+)\)(\d+)/;
		nr.exec( value );
		var cc = RegExp.$1;
		var ac = RegExp.$2;
		var lo = RegExp.$3;
	//	alert( "cc="+cc+" ac="+ac+" lo="+lo );

		value = prefHavePBX ? prefAmtsKennziffer : "";

		if( cc == prefLandesKennzahl )
			{
			if( ac == prefVorwahl )
				{
				if( lo.indexOf( prefSubscriber ) == 0 )
					{
					var pLen = prefSubscriber.length;
					value = lo.substring( pLen, lo.length );
					}
				else
					{
					value += lo;
					}
				}
			else
				{
				value += prefVorwahlFernamt + ac + lo;
				}
			}
		else
			{
			value += prefVorwahlIntlamt + cc + ac + lo;
			}
		}
	return value;
	}


	//	Die Nummer im Display wird gewaehlt
	//
function dialNumber( number )
	{
	var display = document.getElementById("display");

	var value = display.value;
	var label = display.value;

	if( number )
		{
		number = number.replace( /tel:/, "" );
		number = number.replace( /wtai:\/\/wp\/mc;/, "" );
		number = number.replace( /\//g, "" );

		value = number;
		label = number;
		}
	else
		{
		if( display.selectedItem )
			{
			label = display.selectedItem.getAttribute( "label" );
			value = display.selectedItem.getAttribute( "value" );
			}
		}

	var tosave = normalizeNumber( value );
	value = localizeNumber( tosave );

	if( getBoolPref( "flag.dialack", true ) )
		{
		var check = confirm( 'Dialing ' + value );
		if( check == false ) return;
		}

	// Da ein File.open eines Devices unter Windows mit der jslib nicht moeglich ist,
	// wird cmd gestartet, und die Nummer mit echo nach COMx gesendet.
	//
	var par = getCharPref( "cmd.par", "" );
	var prg = getCharPref( "cmd.prg", "" );
	par = par.replace( /\$DIENUMMER/, value );
	var file = new FileUtils();
	file.spawn( prg, [par] ); 

	if( getBoolPref( "flag.dtmfon", true ) ) dialDtmf( number );

	RecentListAddItem( label, tosave );
	}


	//	Die Nummer im Display wird gepiept
	//
function dialDtmf( number )
	{
	var display = document.getElementById("display");

	var value = display.value;
	var label = display.value;

	if( number )
		{
		value = number;
		label = number;
		}
	else
		{
		if (display.selectedItem )
			{
			label = display.selectedItem.getAttribute("label");
			value = display.selectedItem.getAttribute("value");
			}
		}

	if( !getBoolPref( "flag.dtmfpure", true ) )
		value = localizeNumber( normalizeNumber( value ) );

	window.setTimeout('playNextSound("'+value.toLowerCase()+'",0)',150);
	}


function playNextSound( value, index )
	{
	// nur geladene sounds abspielen, nicht definierte sounds
	// hinterlassen nur eine Pause
	//
	try	 { gDizzySound[value[index]].play(); }
	catch(e) { }

	if( value.length > ++index )
		window.setTimeout('playNextSound("'+value+'",'+index+')',150);
	}


function gotoTelURL( url )	// tel: oder wtai://wp/mc URLs
	{
	var exp = /^tel:[\/\+\(\)\- \d]+/i;
	if( exp.test( url ) ) return dialNumber( url );

	var exp = /^wtai:\/\/wp\/mc;[\+\(\)\- \d]+/i;
	if( exp.test( url ) ) return dialNumber( url );

	alert( '"' + url + '" is no valid phone-URI' );
	}


function gotoTelSEL( sel )	// Textselektion
	{
	var exp = /^[\+\(\)\- \d]+$/i;
	if( exp.test( sel ) ) return dialNumber( sel );

	alert( '"' + sel + '" is no valid phonenumber' );
	}


// ---------------------------------------------------------
//
//	File-Menu
//

function fileOpenDialer()
	{
	alert( "File open clicked" );
	}

function fileSaveDialer()
	{
	alert( "File Save clicked" );
	}

function fileNewDialer()
	{
	alert( "File New clicked" );
	}

function fileExitDialer()
	{
	window.close();		// loest onunloadDialer() aus
	}


// ---------------------------------------------------------
//
//	RecentList
//

function RecentListInit()
	{
	var recentlist=document.getElementById("display");
	var sources=recentlist.database.GetDataSources();
	var rootnode=RDF.GetResource( recentlist.ref );
//	var rootnode=RDF.GetResource("urn:dizzy:recent");	// auf ref-attribut umstellen

	while ( sources.hasMoreElements() )
		{
		try
			{
			dsource=sources.getNext();
			dsource=dsource.QueryInterface(Components.interfaces.nsIRDFDataSource);
 	
			RDFC.Init(dsource,rootnode);
			}
		catch (e)
			{
			RDFCUtils.MakeSeq(dsource,rootnode);
			RDFC.Init(dsource,rootnode);
			}
		}
	}


function RecentListAddItem( label, value )
	{
	var newvalue=RDF.GetLiteral( value );
	var newlabel=RDF.GetLiteral( label );
	var valueprop=RDF.GetResource("http://www.example.com/recent#Value");
	var labelprop=RDF.GetResource("http://www.example.com/recent#Label");

	var elements = RDFC.GetElements();
	while( elements.hasMoreElements() )
		{
		var element = elements.getNext();
		if( dsource.HasAssertion(element, labelprop, newlabel, true) &&
		    dsource.HasAssertion(element, valueprop, newvalue, true) )
			{
			return;		// the new value is already there
			}
		}

	var display = document.getElementById("display");
	display.appendItem( label, value );
	display.value = value;

	return;

	// if I'm here, the value is really new, not in the database
	//
//	var newelement=RDF.GetResource("urn:dizzy:recent:item"+(RDFC.GetCount()+1));

	var newelement=RDF.GetAnonymousResource();	// geht nach ~user/localstore.rdf

	dsource.Assert(newelement,valueprop,newvalue,true);
	dsource.Assert(newelement,labelprop,newlabel,true);

	RDFC.InsertElementAt(newelement,1,true);
	dsource.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource).Flush();

	} 


function RecentListDeleteItem( )
	{
	var newlabel=RDF.GetLiteral( display.selectedItem.getAttribute("label") );
	var newvalue=RDF.GetLiteral( display.selectedItem.getAttribute("value") );
	var labelprop=RDF.GetResource("http://www.example.com/recent#Label");
	var valueprop=RDF.GetResource("http://www.example.com/recent#Value");

	var elements = RDFC.GetElements();
	while( elements.hasMoreElements() )
		{
		var element = elements.getNext();
		if( dsource.HasAssertion(element, labelprop, newlabel, true) &&
		    dsource.HasAssertion(element, valueprop, newvalue, true) )
			{
			RDFC.RemoveElement( element,true );	// Treffer, raus damit
			}
		}
	dsource.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource).Flush();

	var display = document.getElementById("display");
	display.removeItemAt(display.selectedIndex);
	clearDisplay();
	}


	//	Der angezeigten Nummer wird ein Label zugeordnet.
	//
function RecentListEditLabel( )
	{
	var display = document.getElementById("display");
	var value = display.value;
	var label = prompt("Geben Sie eine Beschreibung fuer\n" + value, "");
	if (label == "") return;

	display.appendItem( label, value );

//	display.selectedItem.label = label;
//	display.removeItemAt(display.selectedIndex);
//	display.label = label;
	}


// Drag and Drop Text to the dial-button
//
var dialObserver =
	{
	onDrop : function( event, transferData, session )
		{
		var wtai = /wtai:\/\/wp\/mc;\s*(\d+)/;
		var tel  = /tel:(+?[\d \.\(\)\-pw\*\#ABCD]+)/;
		var text = /(\+?\d+\(?\d+\)?\d+\-?\d+)/;

		var erg = transferData.data.replace( /\s/g, "" );

		if( wtai.test( erg ) )	// ist es eine wtai-MakeCall-URI?
			{
			wtai.exec( erg );
			erg = RegExp.$1;
			}
		else
			{
			if( tel.test( erg ) )	// ist es eine tel-URI (RFC 2806)
				{
				tel.exec( erg );
				erg = RegExp.$1;
				}
			else
				{
				if( text.test( erg ) )	// oder nur plaintext
					{
					text.exec( erg );
					erg = RegExp.$1;
					}
				else
					{
					erg = "";
					}
				}
			}
		if( erg != "" ) dialNumber( erg );
		},

	onDragOver : function( event, flavour, session )
		{
		},

	getSupportedFlavours : function( )
		{
		var flavours = new FlavourSet( );
	//	flavours.appendFlavour( "application/x-moz-url" );	// a url
		flavours.appendFlavour( "text/unicode" );		// plain text
		return flavours;
		}
	};


function displayDizzyVersion()
	{
	window.openDialog( getBrowserURL(), "_blank",
		'chrome,resizable,extrachrome',
		'chrome://dizzy/content/about.xul' );
	}
