@rem = 'You need PERL5 for this! This is only the DOS-ExecHeader.
@perl -S %0 %*
@exit ';

#
#	Dieses script befragt numberingplans.com und erzeugt
#	eine rdf-Liste der Countrycodes und Laendernamen, die
#	fuer die preferences von dizzy genutzt werden kann.
#
#	Aufruf: countrycode2rdf > e164cc.rdf
#
#	Die erzeugte Datei e164cc.rdf gehoert nach chrome://dizzy/content/
#
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
#
#	This script asks numberingplans.com und generates
#	a rdf-file of all Countrycodes and Countrynames.
#	The result can be used for dizzy's preferences.
#
#	usage: countrycode2rdf > e164cc.rdf
#
#	The created file e164cc.rdf belongs to chrome://dizzy/content/
#

require Exporter;
use LWP::UserAgent;

$ua  = new LWP::UserAgent;
$req = new HTTP::Request('GET' => "http://www.numberingplans.com/index.php3?goto=guide&topic=ccs");
$res = $ua->request($req);

print "could not get $url\n" if( ! $res->is_success );

print "<?xml version=\"1.0\"?>
<RDF:RDF xmlns:CC=\"http://www.example.com/e164cc#\"
	xmlns:RDF=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#\">

<!-- generated by $0 -->

";

my $i = 1;
foreach ( split( /<tr>/, $res->content ) )
	{
	s/[\n\r]//g;
	s/tr>.*$//g;

	@l = split( /<td>/ );			# <tr>-Zeile in Felder zerlegen

	if( $l[1] =~ />\s*\+(\d+)\s*</ )	# 1. Feld der <tr> ist der countrycode
		{
		my $cc = $1;

		$l[2] =~ />\s*([^\d<]+)\s*</;	# 2. Feld der <tr> ist der countryname
		my $cn = iso88951_to_utf8($1);	# Sonderzeichen nach UTF-8 konvertieren
		$cn =~ s/\s*$//g;		# whitespaces am Ende weg

		print "<RDF:Description about=\"rdf:cc".$i++."\" CC:countrycode=\"".$cc."\" CC:countryname=\"".$cn."\" />\n";
		}
	}
print "\n<RDF:Seq about=\"urn:dizzy:e164cc\">\n";
for( $j=1; $j<$i; $j++ ) { print "\t<RDF:li resource=\"rdf:cc".$j."\"/>\n"; }
print "</RDF:Seq>\n\n</RDF:RDF>\n";


sub iso88951_to_utf8	# konvertiert String ISO-8859-1 nach Unicode UTF-8
	{		# U-00000080 - U-000000FF => 110000xx 10xxxxxx
	my $s = shift;
	$s =~ s/([\x80-\xFF])/chr(192+(ord($1)>>6)).chr(128+(ord($1)&63))/ge;
	return $s;
	}
